> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Collect a posted debit memo

POST https://rest.test.zuora.com/v1/debit-memos/{debitMemoKey}/collect
Content-Type: application/json

**Note:** This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.

This API operation provides an easy way to let the client-side to collect an existing posted debit memo.
It supports the following steps:
  1. Apply unapplied credit memos to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied credit memos.
  2. Apply unapplied payments to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied payments.
  3. Process payment to the posted debit memo if there is an open-balance on it.

**Restrictions**

Since this API will do lots of works, and some of them are resource consuming, we need to restrict the usage of this API by the following conditions:
  1. If the target debit memo gets more than 10 debit memo items, the request will be rejected.
  2. If `CreditMemo` is specified in `applicationOrder`, when there are more than 25 credit memos will be used to apply to the debit memo, the request will be rejected.
  3. If `CreditMemo` is specified in `applicationOrder`, when there are more than 100 credit memo items will be used to apply to the debit memo, the request will be rejected.
  4. If `UnappliedPayment` is specified in `applicationOrder`, when there are more than 25 payments will be used to apply to the debit memo, the request will be rejected.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/debit-memos/post-debit-memo-collect

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `debitMemoKey` (string, required) — The ID or number of a posted debit memo. For example, 8a8082e65b27f6c3015ba419f3c2644e.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a DebitMemoCollectRequest.

- `applicationOrder` (list of string, optional) — The priority order to apply credit memos and/or unapplied payments to the debit memo. Possible item values are: `CreditMemo`, `UnappliedPayment`. **Note:** - This field is valid only if the `applyCredit` field is set to `true`. - If no value is specified for this field, the default priority order is used, ["CreditMemo", "UnappliedPayment"], to apply credit memos first and then apply unapplied payments. - If only one item is specified, only the items of the spedified type are applied to invoices. For example, if the value is `["CreditMemo"]`, only credit memos are used to apply the debit memo.
- `applyCredit` (boolean, optional, default: false) — Whether to automatically apply credit memos or unapplied payments, or both to the debit memo. If the value is `true`, the credit memo or unapplied payment, or both will be automatically applied to the debit memo. If no value is specified or the value is `false`, no action is taken.
- `collect` (boolean, optional, default: false) — Indicates if the current request needs to collect payment or not.
- `payment` (DebitMemoCollectRequestPayment, optional) — Some detail info that would be used to processed an electronic payment. The info would only effect when `collect` set to `true`.

## Response

### 200

OK

- `appliedCreditMemos` (list of DebitMemoCollectResponseAppliedCreditMemos, optional) — The information about which credit memo applied to the specific debit memo.
- `appliedPayments` (list of DebitMemoCollectResponseAppliedPayments, optional) — The information about which payment applied to the specific debit memo.
- `debitMemo` (DebitMemoCollectResponseDebitMemo, optional) — The information about the debit memo that just collected.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `processedPayment` (DebitMemoCollectResponseProcessedPayment, optional) — The information about the payment that newly processed to the debit memo.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### DebitMemoCollectRequestPayment

Some detail info that would be used to processed an electronic payment. The info would only effect when `collect` set to `true`.

- `gatewayId` (string, optional) — The ID of the gateway instance that processes the payment. The ID must be a valid gateway instance ID and this gateway must support the specific payment method. If no gateway ID is specified in the request body, the default gateway for the customer account is used automatically, if this default one is not configured, the default gateway of the tenant would be used.
- `paymentMethodId` (string, optional) — The unique ID of the payment method that the customer used to make the payment. If no payment method ID is specified in the request body, the default payment method for the customer account is used automatically. If the default payment method is different from the type of payments that you want to create, an error occurs.

### DebitMemoCollectResponseAppliedCreditMemos

- `appliedAmount` (double, optional) — The applied amount of the credit memo to the debit memo.
- `id` (string, optional) — The unique ID of the credit memo.
- `number` (string, optional) — The unique identification number of the credit memo.
- `unappliedAmount` (double, optional) — The unapplied amount of the credit memo after applied to the debit memo.

### DebitMemoCollectResponseAppliedPayments

- `appliedAmount` (double, optional) — The applied amount of the payment to the debit memo.
- `id` (string, optional) — The unique ID of the payment.
- `number` (string, optional) — The unique identification number of the payment.
- `unappliedAmount` (double, optional) — The unapplied amount of the payment after applied to the debit memo.

### DebitMemoCollectResponseDebitMemo

The information about the debit memo that just collected.

- `id` (string, optional) — The unique ID of the debit memo.
- `number` (string, optional) — The unique identification number of the debit memo.

### DebitMemoCollectResponseProcessedPayment

The information about the payment that newly processed to the debit memo.

- `amount` (double, optional) — The total amount of the payment.
- `gatewayId` (string, optional) — The ID of the gateway instance that processes the payment.
- `gatewayResponse` (string, optional) — The message returned from the payment gateway for the payment. This message is gateway-dependent.
- `gatewayResponseCode` (string, optional) — The code returned from the payment gateway for the payment. This code is gateway-dependent.
- `id` (string, optional) — The unique ID of the created payment. For example, 4028905f5a87c0ff015a87eb6b75007f.
- `number` (string, optional) — The unique identification number of the payment. For example, P-00000001.
- `paymentMethodId` (string, optional) — The unique ID of the payment method that the customer used to make the payment.
- `status` (enum, optional) — The status of the payment.
  - Allowed values: `Processing`, `Processed`, `Error`, `Canceled`

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "applyCredit": true,
  "collect": true
}
```

**Response**

```json
{
  "appliedCreditMemos": [],
  "appliedPayments": [],
  "debitMemo": {
    "id": "8ad0912492f64b9001931936cac36351",
    "number": "DM00000001"
  },
  "processedPayment": {
    "amount": 10,
    "gatewayId": "8ad095dd813e750f0181461a8e350ce7",
    "gatewayResponse": "This transaction has been approved by the gateway.",
    "gatewayResponseCode": "approve",
    "id": "8ad0869992f632860193249dfe1a0ead",
    "number": "P-00001541",
    "paymentMethodId": "8ad09bce83f1da020183f97e24821c4b",
    "status": "Processed"
  },
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect"

payload = {
    "applyCredit": True,
    "collect": True
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"applyCredit":true,"collect":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect"

	payload := strings.NewReader("{\n  \"applyCredit\": true,\n  \"collect\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"applyCredit\": true,\n  \"collect\": true\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"applyCredit\": true,\n  \"collect\": true\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect', [
  'body' => '{
  "applyCredit": true,
  "collect": true
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"applyCredit\": true,\n  \"collect\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "applyCredit": true,
  "collect": true
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/debit-memos/debitMemoKey/collect")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```